Merge branch 'for-4.7/upstream' into for-linus
[deliverable/linux.git] / scripts / kconfig / Makefile
1 # ===========================================================================
2 # Kernel configuration targets
3 # These targets are used from top-level makefile
4
5 PHONY += xconfig gconfig menuconfig config silentoldconfig update-po-config \
6 localmodconfig localyesconfig
7
8 ifdef KBUILD_KCONFIG
9 Kconfig := $(KBUILD_KCONFIG)
10 else
11 Kconfig := Kconfig
12 endif
13
14 ifeq ($(quiet),silent_)
15 silent := -s
16 endif
17
18 # We need this, in case the user has it in its environment
19 unexport CONFIG_
20
21 xconfig: $(obj)/qconf
22 $< $(silent) $(Kconfig)
23
24 gconfig: $(obj)/gconf
25 $< $(silent) $(Kconfig)
26
27 menuconfig: $(obj)/mconf
28 $< $(silent) $(Kconfig)
29
30 config: $(obj)/conf
31 $< $(silent) --oldaskconfig $(Kconfig)
32
33 nconfig: $(obj)/nconf
34 $< $(silent) $(Kconfig)
35
36 silentoldconfig: $(obj)/conf
37 $(Q)mkdir -p include/config include/generated
38 $< $(silent) --$@ $(Kconfig)
39
40 localyesconfig localmodconfig: $(obj)/streamline_config.pl $(obj)/conf
41 $(Q)mkdir -p include/config include/generated
42 $(Q)perl $< --$@ $(srctree) $(Kconfig) > .tmp.config
43 $(Q)if [ -f .config ]; then \
44 cmp -s .tmp.config .config || \
45 (mv -f .config .config.old.1; \
46 mv -f .tmp.config .config; \
47 $(obj)/conf $(silent) --silentoldconfig $(Kconfig); \
48 mv -f .config.old.1 .config.old) \
49 else \
50 mv -f .tmp.config .config; \
51 $(obj)/conf $(silent) --silentoldconfig $(Kconfig); \
52 fi
53 $(Q)rm -f .tmp.config
54
55 # Create new linux.pot file
56 # Adjust charset to UTF-8 in .po file to accept UTF-8 in Kconfig files
57 update-po-config: $(obj)/kxgettext $(obj)/gconf.glade.h
58 $(Q)$(kecho) " GEN config.pot"
59 $(Q)xgettext --default-domain=linux \
60 --add-comments --keyword=_ --keyword=N_ \
61 --from-code=UTF-8 \
62 --files-from=$(srctree)/scripts/kconfig/POTFILES.in \
63 --directory=$(srctree) --directory=$(objtree) \
64 --output $(obj)/config.pot
65 $(Q)sed -i s/CHARSET/UTF-8/ $(obj)/config.pot
66 $(Q)(for i in `ls $(srctree)/arch/*/Kconfig \
67 $(srctree)/arch/*/um/Kconfig`; \
68 do \
69 $(kecho) " GEN $$i"; \
70 $(obj)/kxgettext $$i \
71 >> $(obj)/config.pot; \
72 done )
73 $(Q)$(kecho) " GEN linux.pot"
74 $(Q)msguniq --sort-by-file --to-code=UTF-8 $(obj)/config.pot \
75 --output $(obj)/linux.pot
76 $(Q)rm -f $(obj)/config.pot
77
78 # These targets map 1:1 to the commandline options of 'conf'
79 simple-targets := oldconfig allnoconfig allyesconfig allmodconfig \
80 alldefconfig randconfig listnewconfig olddefconfig
81 PHONY += $(simple-targets)
82
83 $(simple-targets): $(obj)/conf
84 $< $(silent) --$@ $(Kconfig)
85
86 PHONY += oldnoconfig savedefconfig defconfig
87
88 # oldnoconfig is an alias of olddefconfig, because people already are dependent
89 # on its behavior (sets new symbols to their default value but not 'n') with the
90 # counter-intuitive name.
91 oldnoconfig: olddefconfig
92
93 savedefconfig: $(obj)/conf
94 $< $(silent) --$@=defconfig $(Kconfig)
95
96 defconfig: $(obj)/conf
97 ifeq ($(KBUILD_DEFCONFIG),)
98 $< $(silent) --defconfig $(Kconfig)
99 else
100 ifneq ($(wildcard $(srctree)/arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG)),)
101 @$(kecho) "*** Default configuration is based on '$(KBUILD_DEFCONFIG)'"
102 $(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG) $(Kconfig)
103 else
104 @$(kecho) "*** Default configuration is based on target '$(KBUILD_DEFCONFIG)'"
105 $(Q)$(MAKE) -f $(srctree)/Makefile $(KBUILD_DEFCONFIG)
106 endif
107 endif
108
109 %_defconfig: $(obj)/conf
110 $(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$@ $(Kconfig)
111
112 configfiles=$(wildcard $(srctree)/kernel/configs/$@ $(srctree)/arch/$(SRCARCH)/configs/$@)
113
114 %.config: $(obj)/conf
115 $(if $(call configfiles),, $(error No configuration exists for this target on this architecture))
116 $(Q)$(CONFIG_SHELL) $(srctree)/scripts/kconfig/merge_config.sh -m .config $(configfiles)
117 +$(Q)yes "" | $(MAKE) -f $(srctree)/Makefile oldconfig
118
119 PHONY += kvmconfig
120 kvmconfig: kvm_guest.config
121 @:
122
123 PHONY += xenconfig
124 xenconfig: xen.config
125 @:
126
127 PHONY += tinyconfig
128 tinyconfig:
129 $(Q)$(MAKE) -f $(srctree)/Makefile allnoconfig tiny.config
130
131 # Help text used by make help
132 help:
133 @echo ' config - Update current config utilising a line-oriented program'
134 @echo ' nconfig - Update current config utilising a ncurses menu based'
135 @echo ' program'
136 @echo ' menuconfig - Update current config utilising a menu based program'
137 @echo ' xconfig - Update current config utilising a Qt based front-end'
138 @echo ' gconfig - Update current config utilising a GTK+ based front-end'
139 @echo ' oldconfig - Update current config utilising a provided .config as base'
140 @echo ' localmodconfig - Update current config disabling modules not loaded'
141 @echo ' localyesconfig - Update current config converting local mods to core'
142 @echo ' silentoldconfig - Same as oldconfig, but quietly, additionally update deps'
143 @echo ' defconfig - New config with default from ARCH supplied defconfig'
144 @echo ' savedefconfig - Save current config as ./defconfig (minimal config)'
145 @echo ' allnoconfig - New config where all options are answered with no'
146 @echo ' allyesconfig - New config where all options are accepted with yes'
147 @echo ' allmodconfig - New config selecting modules when possible'
148 @echo ' alldefconfig - New config with all symbols set to default'
149 @echo ' randconfig - New config with random answer to all options'
150 @echo ' listnewconfig - List new options'
151 @echo ' olddefconfig - Same as silentoldconfig but sets new symbols to their'
152 @echo ' default value'
153 @echo ' kvmconfig - Enable additional options for kvm guest kernel support'
154 @echo ' xenconfig - Enable additional options for xen dom0 and guest kernel support'
155 @echo ' tinyconfig - Configure the tiniest possible kernel'
156
157 # lxdialog stuff
158 check-lxdialog := $(srctree)/$(src)/lxdialog/check-lxdialog.sh
159
160 # Use recursively expanded variables so we do not call gcc unless
161 # we really need to do so. (Do not call gcc as part of make mrproper)
162 HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(check-lxdialog) -ccflags) \
163 -DLOCALE
164
165 # ===========================================================================
166 # Shared Makefile for the various kconfig executables:
167 # conf: Used for defconfig, oldconfig and related targets
168 # nconf: Used for the nconfig target.
169 # Utilizes ncurses
170 # mconf: Used for the menuconfig target
171 # Utilizes the lxdialog package
172 # qconf: Used for the xconfig target
173 # Based on Qt which needs to be installed to compile it
174 # gconf: Used for the gconfig target
175 # Based on GTK+ which needs to be installed to compile it
176 # object files used by all kconfig flavours
177
178 lxdialog := lxdialog/checklist.o lxdialog/util.o lxdialog/inputbox.o
179 lxdialog += lxdialog/textbox.o lxdialog/yesno.o lxdialog/menubox.o
180
181 conf-objs := conf.o zconf.tab.o
182 mconf-objs := mconf.o zconf.tab.o $(lxdialog)
183 nconf-objs := nconf.o zconf.tab.o nconf.gui.o
184 kxgettext-objs := kxgettext.o zconf.tab.o
185 qconf-cxxobjs := qconf.o
186 qconf-objs := zconf.tab.o
187 gconf-objs := gconf.o zconf.tab.o
188
189 hostprogs-y := conf nconf mconf kxgettext qconf gconf
190
191 clean-files := qconf.moc .tmp_qtcheck .tmp_gtkcheck
192 clean-files += zconf.tab.c zconf.lex.c zconf.hash.c gconf.glade.h
193 clean-files += config.pot linux.pot
194
195 # Check that we have the required ncurses stuff installed for lxdialog (menuconfig)
196 PHONY += $(obj)/dochecklxdialog
197 $(addprefix $(obj)/,$(lxdialog)): $(obj)/dochecklxdialog
198 $(obj)/dochecklxdialog:
199 $(Q)$(CONFIG_SHELL) $(check-lxdialog) -check $(HOSTCC) $(HOST_EXTRACFLAGS) $(HOSTLOADLIBES_mconf)
200
201 always := dochecklxdialog
202
203 # Add environment specific flags
204 HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(srctree)/$(src)/check.sh $(HOSTCC) $(HOSTCFLAGS))
205
206 # generated files seem to need this to find local include files
207 HOSTCFLAGS_zconf.lex.o := -I$(src)
208 HOSTCFLAGS_zconf.tab.o := -I$(src)
209
210 LEX_PREFIX_zconf := zconf
211 YACC_PREFIX_zconf := zconf
212
213 HOSTLOADLIBES_qconf = $(KC_QT_LIBS)
214 HOSTCXXFLAGS_qconf.o = $(KC_QT_CFLAGS)
215
216 HOSTLOADLIBES_gconf = `pkg-config --libs gtk+-2.0 gmodule-2.0 libglade-2.0`
217 HOSTCFLAGS_gconf.o = `pkg-config --cflags gtk+-2.0 gmodule-2.0 libglade-2.0` \
218 -Wno-missing-prototypes
219
220 HOSTLOADLIBES_mconf = $(shell $(CONFIG_SHELL) $(check-lxdialog) -ldflags $(HOSTCC))
221
222 HOSTLOADLIBES_nconf = $(shell \
223 pkg-config --libs menuw panelw ncursesw 2>/dev/null \
224 || pkg-config --libs menu panel ncurses 2>/dev/null \
225 || echo "-lmenu -lpanel -lncurses" )
226 $(obj)/qconf.o: $(obj)/.tmp_qtcheck
227
228 ifeq ($(MAKECMDGOALS),xconfig)
229 $(obj)/.tmp_qtcheck: $(src)/Makefile
230 -include $(obj)/.tmp_qtcheck
231
232 # Qt needs some extra effort...
233 $(obj)/.tmp_qtcheck:
234 @set -e; $(kecho) " CHECK qt"; \
235 if pkg-config --exists Qt5Core; then \
236 cflags="-std=c++11 -fPIC `pkg-config --cflags Qt5Core Qt5Gui Qt5Widgets`"; \
237 libs=`pkg-config --libs Qt5Core Qt5Gui Qt5Widgets`; \
238 moc=`pkg-config --variable=host_bins Qt5Core`/moc; \
239 elif pkg-config --exists QtCore; then \
240 cflags=`pkg-config --cflags QtCore QtGui`; \
241 libs=`pkg-config --libs QtCore QtGui`; \
242 moc=`pkg-config --variable=moc_location QtCore`; \
243 else \
244 echo >&2 "*"; \
245 echo >&2 "* Could not find Qt via pkg-config."; \
246 echo >&2 "* Please install either Qt 4.8 or 5.x. and make sure it's in PKG_CONFIG_PATH"; \
247 echo >&2 "*"; \
248 exit 1; \
249 fi; \
250 echo "KC_QT_CFLAGS=$$cflags" > $@; \
251 echo "KC_QT_LIBS=$$libs" >> $@; \
252 echo "KC_QT_MOC=$$moc" >> $@
253 endif
254
255 $(obj)/gconf.o: $(obj)/.tmp_gtkcheck
256
257 ifeq ($(MAKECMDGOALS),gconfig)
258 -include $(obj)/.tmp_gtkcheck
259
260 # GTK+ needs some extra effort, too...
261 $(obj)/.tmp_gtkcheck:
262 @if `pkg-config --exists gtk+-2.0 gmodule-2.0 libglade-2.0`; then \
263 if `pkg-config --atleast-version=2.0.0 gtk+-2.0`; then \
264 touch $@; \
265 else \
266 echo >&2 "*"; \
267 echo >&2 "* GTK+ is present but version >= 2.0.0 is required."; \
268 echo >&2 "*"; \
269 false; \
270 fi \
271 else \
272 echo >&2 "*"; \
273 echo >&2 "* Unable to find the GTK+ installation. Please make sure that"; \
274 echo >&2 "* the GTK+ 2.0 development package is correctly installed..."; \
275 echo >&2 "* You need gtk+-2.0, glib-2.0 and libglade-2.0."; \
276 echo >&2 "*"; \
277 false; \
278 fi
279 endif
280
281 $(obj)/zconf.tab.o: $(obj)/zconf.lex.c $(obj)/zconf.hash.c
282
283 $(obj)/qconf.o: $(obj)/qconf.moc
284
285 quiet_cmd_moc = MOC $@
286 cmd_moc = $(KC_QT_MOC) -i $< -o $@
287
288 $(obj)/%.moc: $(src)/%.h $(obj)/.tmp_qtcheck
289 $(call cmd,moc)
290
291 # Extract gconf menu items for i18n support
292 $(obj)/gconf.glade.h: $(obj)/gconf.glade
293 $(Q)intltool-extract --type=gettext/glade --srcdir=$(srctree) \
294 $(obj)/gconf.glade
This page took 0.035682 seconds and 6 git commands to generate.